//==========================================================================
// Mouse Injector for GoldenEye 007/Perfect Dark
//==========================================================================
// Copyright (c) 2017, stolen + carnivorous's fixes
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//     * Redistributions of source code must retain the above copyright
//       notice, this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright
//       notice, this list of conditions and the following disclaimer in the
//       documentation and/or other materials provided with the distribution.
//     * Neither the name of the <organization> nor the
//       names of its contributors may be used to endorse or promote products
//       derived from this software without specific prior written permission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL STOLEN BE LIABLE FOR ANY
// DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//==========================================================================
// input for interface
#define K_CTRL GetAsyncKeyState(0x11) // control
#define K_4 GetAsyncKeyState(0x34) // key '4'
#define K_5 GetAsyncKeyState(0x35) // key '5'
#define K_6 GetAsyncKeyState(0x36) // key '6'
#define K_7 GetAsyncKeyState(0x37) // key '7'
#define K_8 GetAsyncKeyState(0x38) // key '8'
#define K_9 GetAsyncKeyState(0x39) // key '9'
#define K_0 GetAsyncKeyState(0x30) // key '0'
#define K_PLUS (GetAsyncKeyState(0x6B) || GetAsyncKeyState(0xBB)) // key '+'
#define K_MINUS (GetAsyncKeyState(0x6D) || GetAsyncKeyState(0xBD)) // key '-'
#define K_F8 GetAsyncKeyState(0x77) // key 'F8'
#define K_F9 GetAsyncKeyState(0x78) // key 'F9'
// misc
#define TITLE "GoldenEye 007/Perfect Dark Mouse Injector\n"
#define LINE "_______________________________________________________________"
#define GEGUNAIMLIMIT 6.879164696
#define GECROSSHAIRLIMIT 5.159373283
#define PDGUNAIMLIMIT 14.12940025
#define PDCROSSHAIRLIMIT 18.76135635
#define TANKXROTATIONLIMIT 6.283093
#define BIKEXROTATIONLIMIT 6.282185078
#define BIKEROLLLIMIT 0.7852724195
#define TIMESTEP tickrate / 1000
#define ResetCrouchToggle() safetoduck = 1, safetostand = 0, crouchstance = 0

// GOLDENEYE ADDRESSES - OFFSET ADDRESSES BELOW (REQUIRES PLAYERBASE TO USE)
#define GE_deathflag 0x000D3038 - 0x000D2FFC
#define GE_camx 0x000D30A8 - 0x000D2FFC
#define GE_camy 0x000D30B8 - 0x000D2FFC
#define GE_fov 0x000D4124 - 0x000D2FFC
#define GE_crosshairx 0x000D3F50 - 0x000D2FFC
#define GE_crosshairy 0x000D3F54 - 0x000D2FFC
#define GE_watch 0x000D3128 - 0x000D2FFC
#define GE_crouchheight 0x000D3000 - 0x000D2FFC
#define GE_gunx 0x000D3F64 - 0x000D2FFC
#define GE_guny 0x000D3F68 - 0x000D2FFC
#define GE_aimingflag 0x000D3084 - 0x000D2FFC
#define GE_currentweapon 0x000D37D0 - 0x000D2FFC
#define GE_multipausemenu 0x000A9D24 - 0x000A73FC
// STATIC ADDRESSES BELOW
#define BONDDATA ReadMemoryInt(ReadMemoryInt(0x8007A0B0 - 0x80000000, 0), 0) - 0x80000000 + 0x9C // playable character point (used for all characters)
#ifndef PLAYER2MODE
	#define GE_controller 0x00067CA4 // player 1 controller address
#else
	#define GE_controller 0x00067CAC // player 2 controller address
#endif
#define GE_camera 0x00036494 // camera flag (0 = multiplayer, 1 = map overview, 2 = start flyby, 3 = in flyby, 4 = player in control, 5 = trigger restart map)
#define GE_exit 0x000364B0 // exit flag (0 = disable controls, 1 = enable controls)
#define GE_pause 0x00048370 // pause flag (1 = GE is paused)
#define GE_menupage 0x0002A8C0 // menu page id
#define GE_menux 0x0002A908 // crosshair menu cursor x axis
#define GE_menuy 0x0002A90C // crosshair menu cursor y axis
#define GE_tankxrot 0x00036484 // tank x rotation
#define GE_tankflag 0x00036448 // tank flag (0 = walking, 1 = in-tank)
#define GE_matchended 0x0008C700 // multiplayer match flag
#define GE_customweaponflag 0x002ACDD8 // location of the first weapon title (used to detect if user is playing a GE rom hack with custom weapons)

// PERFECT DARK ADDRESSES - OFFSET ADDRESSES BELOW (REQUIRES PLAYERBASE/BIKEBASE TO USE)
#define PD_deathflag 0x001BB778 - 0x001BB74C
#define PD_camx 0x001BB7E4 - 0x001BB74C
#define PD_camy 0x001BB7F4 - 0x001BB74C
#define PD_fov 0x001BCEE8 - 0x001BB74C
#define PD_crosshairx 0x001BCD08 - 0x001BB74C
#define PD_crosshairy 0x001BCD0C - 0x001BB74C
#define PD_grabflag 0x001BB850 - 0x001BB74C
#define PD_gunrx 0x001BC374 - 0x001BB74C
#define PD_gunry 0x001BC378 - 0x001BB74C
#define PD_gunlx 0x001BCB18 - 0x001BB74C
#define PD_gunly 0x001BCB1C - 0x001BB74C
#define PD_aimingflag 0x001BB7C0 - 0x001BB74C
#define PD_bikeroll 0x0052D69C - 0x0052D64C
// STATIC ADDRESSES BELOW
#ifndef PLAYER2MODE
	#define JOANNADATA ReadMemoryInt(ReadMemoryInt(0x8009A024 - 0x80000000, 0), 0) - 0x80000000 + 0xAC // player 1 pointer address
	#define PD_controller 0x0009C7E4 // player 1 controller address
	#define PD_menu 0x00070750 // player 1 menu flag (0 = PD is in menu)
#else
	#define JOANNADATA ReadMemoryInt(ReadMemoryInt(0x8009A028 - 0x80000000, 0), 0) - 0x80000000 + 0xAC // player 2 pointer address
	#define PD_controller 0x0009C7EC // player 2 controller address
	#define PD_menu 0x00070754 // player 2 menu flag (0 = PD is in menu)
#endif
#define PD_camera 0x0009A26C // camera flag (1 = gameplay, 2 & 3 = ???, 4 = multiplayer sweep, 5 = gameover screen, 6 = cutscene mode)
#define PD_pause 0x00084014 // menu flag (1 = PD is paused)
#define PD_menuitem 0x000739F8 // menu item flag (used to check if PD is running)
#define PD_fpscounter 0x0008D934 // fps counter (used to detect when PD is running at locked speed)
#define PD_timer 0x0008DBD0 // we intentionally screw with this timer address to force PD to run at unlocked speed
#define PD_speed 0x0009A424 // used to check if the game is slow motion or normal speed
#define PD_mpspeed 0x000ACB91 // used to check if the match is set to slow motion or normal speed
#define PD_mppause 0x000ACBA2 // used to check if multiplayer match is paused

enum EDITINGCURRENT {EDITINGSENSITIVITY, EDITINGCROSSHAIR};
enum PLAYINGCURRENT {PLAYINGUNKNOWN, PLAYINGGOLDENEYE, PLAYINGPERFECTDARK};

struct
{
	int mousetoggle, sensitivity, crosshair, invertpitch, crouchtoggle, geaimmode, pdradialnav, debug, showsettings, selectedoption, crouchkey;
} CFG = {
	.mousetoggle = 0, .sensitivity = 20, .crosshair = 3, .invertpitch = 0, .crouchtoggle = 0, .geaimmode = 1, .pdradialnav = 1, .debug = 0, .showsettings = 1, .selectedoption = 0, .crouchkey = 0xA2
};

struct
{
	POINT lock; // x and y var for mouse lock position
	ManyMouseEvent event; // var is used to hold current mouse event (movement, buttons, ect)
	int connected; // var stores number of mice connected
} MOUSE;

struct
{
	HANDLE handle; // this stores the emulator process id
	unsigned int offset; // var used for adding emulator offsets to memory address injections (see Read/WriteMemory functions)
	int overclock; // var used to determine if the emu is able to use the PD 60fps hack and GE aiming system (both require a constant high frame rate to work correctly)
} EMU;

int currentgame = PLAYINGUNKNOWN;
int tickrate = 4; // limit the main loop to 250Hz (500Hz is used for oc emulators)
unsigned int playerbase = 0; // stores current player's bonddata/joannadata address
unsigned int bikebase[2]; // stores hoverbike's address and player's last grab state (used to find the exact moment when the player hops on a bike)
int xrot = 0, yrot = 0; // global vars required for MouseMovement function
float crosshairposx, crosshairposy, aimx, aimy; // global vars required for aiming mode function
float xradial = 0, yradial = 0; // global vars required for pd radial nav function
int safetoduck = 1, safetostand = 0, crouchstance = 0; // global vars used for crouch toggle changes (limits tick-tocking)

void Input(void);
void RebindCrouch(void);
void Interface(void);
void LoadSettings(void);
void SaveSettings(void);
void Inject(void);
void Crouch(void);
int GEAimMode(const int aimingflag, const float fov);
void PDRadialNav(void);
void PDSpeedHack(void);
void DetectMap(void);
int Game(void);
int EmulatorDetected(void);
void DebugInterface(void);
int ReadMemoryInt(const unsigned int addr, const unsigned int offset);
float ReadMemoryFloat(const unsigned int addr, const unsigned int offset);
void WriteMemoryInt(const unsigned int addr, const int value, const unsigned int offset);
void WriteMemoryFloat(const unsigned int addr, const float value, const unsigned int offset);
void ClearScreen(void);
void MouseMovement(void);
void SortArray(int *a, const int n);